#include "type.h"
#include "LPC13xx.h"			// LPC13xx Peripheral Registers
#include "core_cm3.h"
#include "SystemTickTimer.h"

static uint32_t systick_count;

static void initSystemTickTimer()
{
	SysTick->CTRL  = 0;
	SysTick->LOAD  = 0;
	SysTick->VAL   = 0;
	SysTick->CTRL  = 0x7;
	SysTick->LOAD  = 72-1;  //720000-1で10msec, 1msec
};

void wait1usec(uint32_t wait_count)
{
	initSystemTickTimer();
	systick_count = 0;
	while(systick_count < wait_count);
	SysTick->CTRL  = 0x0;

	return;
};

void wait1msec(uint32_t wait_count)
{
	initSystemTickTimer();
	systick_count = 0;
	while(systick_count < wait_count*1000);
	SysTick->CTRL  = 0x0;
	
	return;
};

void SysTick_Handler (void)
{
	systick_count ++;
}

